<?php
/********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   		*/
/*												 					*/
/*     This file is part of Uptime Script						 			*/
/*												 					*/
/*     Uptime Script is free software; you can redistribute it and/or modify     		*/
/*     it under the terms of the GNU General Public License as published by      		*/
/*     the Free Software Foundation; either version 2 of the License, or         		*/
/*     (at your option) any later version.									*/
/*																	*/
/*     Uptime Script is distributed in the hope that it will be useful,         			*/
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of          		*/
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*/
/*     GNU General Public License for more details.								*/
/*												 					*/
/*     You should have received a copy of the GNU General Public License         		*/
/*     along with Uptime Script; if not, write to the Free Software					*/
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA 		*/
/********************************************************************************/
/*																	*/
/*         Fichier DataStruct.php										*/
/*         Cr le 31 aout 2006						        			*/
/*									   					*/
/*         Derniere modification: 23 sept 2006   - v4.0.0.alpha-rev11					*/
/*												 					*/
/********************************************************************************/

require('Data.php');
class DataStruct {


	private $data;
	private $maxUptime = 0;
	private $maxSNR = 0;
 	
	public function __construct()	 {
		$this->data = Array();
		for($i = 0;$i<96;$i++) $this->data[$i] = NULL;        			
	}

	public function buildFromSQLResult($result,$islast24 = false) {
	
		if($islast24) {
			// Rcuprons le dernier 1/4 d'heures
			$min = intval(date('i')/15)*15;
			$today = mktime(date('H'),$min,00,date('m'),date('d'),date('Y'));
			$diff1 = mktime(00,00,00,date('m'),date('d'),date('Y'))-$today;
			$diff2 = mktime(00,00,00,date('m'),date('d')+1,date('Y'))-$today;
		}

		while($row = $GLOBALS['SQL']->array_sql($result))  {
			$debug = 0;
			if($islast24) {
				if(mktime(00,00,00,date('m'),date('d'),date('Y')) == $row['day']) {
					$debug = $diff2;
				}
				else $debug = $diff1;
			}
			$tmp = $row['time']-$row['day']+$debug;
			if($tmp%15==0) {
				$i = $tmp/15/60;
				$this->value=true;
				$this->maxUptime= max($this->maxUptime,$row['uptime']);
				$this->maxSNR= max($this->maxSNR,$row['marge']);
				$this->data[$i] = new Data($row['uptime'],$row['ip'],$row['marge'],$row['attenuation'],$row['download'],$row['upload'],$row['voip']);
			}
		} 		 
	}
	
	private function getDataAt($idx) {
		if($idx < 0 || $idx > 96) return false;
		else return $this->data[$idx];
	}
	public function getUptimeAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getUptime();
	}
	public function getIPAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getIP();
	}	
	public function getSNRAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getSNR();
	}
	public function getAttenuationAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getAttenuation();
	}
	public function getDownloadAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getDownload();
	}
	public function getUploadAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getUpload();
	}
	public function getVoIPAt($idx) {
		$tab = $this->getDataAt($idx);
		if($tab != NULL) return $tab->getVoIP();
	}

    public function __toString() {
		//if(!$this->checkEmpty()) $output = "Pas de valeurs";
		//else {
		$output = "<table border=1>";
		$output .= "<tr>";
		$output .= "<th>idx</th>";
		$output .= "<th>".I10N_UPTIME."</th>";
		$output .= "<th>".I10N_IP."</th>";
		$output .= "<th>".I10N_VOIP."</th>";
		$output .= "<th>".I10N_AFF."</th>";
		$output .= "<th>".I10N_SNR."</th>";
		$output .= "<th>".I10N_DOWNLOAD."</th>";
		$output .= "<th>".I10N_UPLOAD."</th>";
		$output .= "</tr>";
     
		for($i=0;$i<96;$i++) {
			$output .= "<tr>";
			$output .= "<td>".$i."</td>";
			$output .= "<td>".$this->getUptimeAt($i)."</td>";
			$output .= "<td>".$this->getIPAt($i)."</td>";
			$output .= "<td>".$this->getvoIPAt($i)."</td>";
			$output .= "<td>".$this->getAttenuationAt($i)."</td>";
			$output .= "<td>".$this->getSNRAt($i)."</td>";
			$output .= "<td>".$this->getDownloadAt($i)."</td>";
			$output .= "<td>".$this->getUploadAt($i)."</td>";
			$output .= "</tr>";
		}
		$output .= "</table>";	
		return $output;		 
    
    }

    public function analyse() {
		// On rcupre toutes les valeurs  non null
		$snr = Array();
		for($i=0;$i<96;$i++)
			if($this->getSNRAt($i) != NULL) $snr[] = $this->getSNRAt($i);
		
		$attenuation = Array();
		for($i=0;$i<96;$i++)
			if($this->getAttenuationAt($i) != NULL) $attenuation[] = $this->getAttenuationAt($i);
		
		$download = Array();
		for($i=0;$i<96;$i++)
			if($this->getDownloadAt($i) != NULL) $download[] = $this->getDownloadAt($i);
		
		$upload = Array();
		for($i=0;$i<96;$i++)
			if($this->getUploadAt($i) != NULL) $upload[] = $this->getUploadAt($i);
		
		$ip = Array();
		for($i=0;$i<96;$i++)
			if($this->getIPAt($i) != NULL) $ip[] = $this->getIPAt($i);
		
		$uptime = Array();
		for($i=0;$i<96;$i++)
			if($this->getUptimeAt($i) != NULL) $uptime[] = $this->getUptimeAt($i);	

		return Array('uptime'=>$uptime,'attenuation'=>$attenuation,'snr'=>$snr,'download'=>$download,'upload'=>$upload,'ip'=>$ip);
	}
	
	public function getSNRMoyenne() {
		$tab = Array();
		for($i=0;$i<96;$i++)
			if($this->getSNRAt($i) != NULL) $tab[] = $this->getSNRAt($i);	
		if(count($tab))
			return round(array_sum($tab)/count($tab),2);
		else return -1;
	}
	public function getAttenuationMoyenne() {
		$tab = Array();
		for($i=0;$i<96;$i++)
			if($this->getAttenuationAt($i) != NULL) $tab[] = $this->getAttenuationAt($i);	
		if(count($tab))
			return round(array_sum($tab)/count($tab),2);
		else return -1;
	}	

    public function getMaxUptime() {
		return $this->maxUptime;
    } // Fin getMaxUptime()
	
    public function getMaxSNR() {
		return $this->maxSNR;
    } // Fin getMaxUptime()
}
?>