<?php
/*********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   */
/*													 */
/*     This file is part of Uptime Script						  */
/*													 */
/*     Uptime Script is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by	*/
/*     the Free Software Foundation; either version 2 of the License, or	   */
/*     (at your option) any later version.						 */
/*													 */ 
/*     Uptime Script is distributed in the hope that it will be useful,	    */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of		*/
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		 */ 
/*     GNU General Public License for more details.					*/
/*													 */
/*     You should have received a copy of the GNU General Public License	   */ 
/*     along with Uptime Script; if not, write to the Free Software		*/
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */
/*********************************************************************************/
/*													 */
/*	   Fichier lib/graph.php								 */
/*	   Cr le 31 mai 2006								 */
/*													 */
/*	   Derniere modification: 31 mai 2006  - v4.0.0.alpha-rev9		 */
/*													 */
/*********************************************************************************/

class Graph {

	private $image_width;
	private $image_height;
	private $debut;
	private $pas;
	private $pxmin;
	private $graph_width;
	private $graph_height;
	private $increment_horizontal;
	private $increment_vertical;
	private $color;

	private $data;

	private $image;

	public function __construct($data,$size,$last24 = false,$voip_active = false) {

		$this->setValues($size);

		// Chargement des donnes

		$this->data = $data;

		$this->image = imagecreate($this->image_width,$this->image_height);

		$this->color = Array();
		$this->ChargerCouleur();
		$this->TracerCadre($last24);
		 
		for($i=0; $i<96;$i++) {
			$this->TracerUptime($i);
			$this->TracerIP($i);
			if($voip_active) $this->TracerVoIP($i);
			$this->TracerMarge($i);
			//$this->TracerAttenuation($i);
			//$this->TracerDownload($i);
			// $this->TracerUpload($i);
		}
		$this->TracerEchelle($size);
		// On envoie le graph au navigateur
		imagerectangle($this->image,$this->debut,0,$this->graph_width+$this->debut,$this->graph_height,$this->color['black']);
		imagepng($this->image);
		header("Content-type: image/png");
	} // Fin __construct()
	
	private function setValues($size) {
		 if($size == "high")
		 {
			$this->image_width = 800;
			$this->image_height = 230;
			$this->debut = 45;
			$this->pas = 7.5;
			$this->pxmin = 2;
			$this->graph_width = 720;
			$this->graph_height = 200;
			$this->increment_horizontal = 20;
			$this->increment_vertical = 30;
		 }
		 elseif($size == "small")
		 {
			$this->image_width = 650;
			$this->image_height = 150;
			$this->debut = 45;
			$this->pas = 6;
			$this->pxmin = 2.5;
			$this->graph_width = 576;
			$this->graph_height = 130;
			$this->increment_horizontal = 13;
			$this->increment_vertical = 24;
		 }		
	} // Fin initValue()
	
    private function ChargerCouleur() {
		// Dfinition des couleurs
		$this->color['white'] = imagecolorallocate ($this->image, 255, 255, 255);
		$this->color['green'] = imagecolorallocate($this->image, 0, 128, 0);
		$this->color['blue'] = imagecolorallocate($this->image, 0, 0, 255);
		$this->color['blue2'] = imagecolorallocate($this->image, 120, 237, 255);
		$this->color['green2'] = imagecolorallocate($this->image, 225, 241, 220);
		$this->color['red'] = imagecolorallocate($this->image, 255, 0, 0);
		$this->color['grey'] = imagecolorallocate($this->image, 200, 200, 200);
		$this->color['ip'] = imagecolorallocate($this->image, 255, 0, 0);
		$this->color['black'] = imagecolorallocate ($this->image, 0, 0, 0);
		$this->color['grey3'] = imagecolorallocate ($this->image, 192, 192, 192);
		$this->color['grey2'] = imagecolorallocate ($this->image, 239, 239, 239);
		$this->color['voip'] = imagecolorallocate($this->image, 0, 80, 0);	
	
	} // Fin ChargerCouleur()
	
    private function TracerCadre($last24) {
		if($last24) {
	  		$j=date('H')-23;
			$min = intval(date('i')/15)*$this->pas;
		}	
		else {
			$j=0;
			$min = 0;
		}
		for($i=$this->debut;$i<$this->graph_width+$this->debut;) { 
			if($last24) $i=$i+$this->increment_vertical;
			imageline($this->image,$i-$min,0,$i-$min,$this->graph_height,$this->color['grey3']);
     
			// plot de marquage des heures
			imageline($this->image,$i-$min,$this->graph_height,$i-$min,$this->graph_height+1,$this->color['black']);

			// Marquage des heures
			if($j < 0) {
				$j2 = 24+$j;
				imagestring($this->image,2,$i-5-$min,$this->graph_height,$j2,$this->color['black']);
			}
			elseif($j >= 10) imagestring($this->image,2,$i-5-$min,$this->graph_height,$j,$this->color['black']);
			else imagestring($this->image,2,$i-2-$min,$this->graph_height,$j,$this->color['black']);
		if(!$last24) $i=$i+$this->increment_vertical;
		$j++;
		}

		//Tracons les lignes horizontales

		for($i=0;$i<=$this->graph_height;) {
			imageline($this->image,$this->debut,$i,$this->graph_width+$this->debut,$i,$this->color['grey3']);
			imageline($this->image,$this->debut-1,$i,$this->debut,$i,$this->color['black']);
			imageline($this->image,$this->debut+$this->graph_width+1,$i,$this->debut+$this->graph_width+1,$i,$this->color['black']);
			$i=$i+$this->increment_horizontal;
		}
	
	}
	
	private function TracerUptime($index) {
		$tmp = $this->data->getUptimeAt($index);
		$i = $index*$this->pas+$this->debut;
		$j = $i + $this->pas;
		if($tmp == NULL) {
			$height = $this->graph_height;
			$km=0;
			// on genere la zone grise
			for($idx= 1; $idx <= $this->increment_vertical; $idx++) {
				$km = $height - $this->pas;
				imageline ( $this->image, $i+1, $height, $j, $km, $this->color['grey']);
				imageline ( $this->image, $i+1, $km, $j, $height, $this->color['grey']);
				$height = $height - $this->pas; 
			}
		}
		elseif($tmp == "" OR $tmp == 0) {
			// on genere la crois rouge 
			$k = $i +1;
			$l = $j -1;
			$mid = $i +($this->pas/2);
			imageline ( $this->image, $k, $this->graph_height-1, $l, $this->graph_height-5, $this->color['red']);
			imageline ( $this->image, $k, $this->graph_height-5, $l, $this->graph_height-1, $this->color['red']);
			imagefilledellipse($this->image, $mid, $this->graph_height-2, 2, 2, $this->color['red']);
		}
		elseif(is_numeric($tmp)) // synchro mesure
		{
			// on trace deux rectanges: un pour le contour et l'autre rempli!			
			$ht = $this->graph_height / $this->data->getMaxUptime();
			$value = $ht * $tmp;
			$haut = $this->graph_height+1 - $value;
			imagefilledrectangle($this->image, $i, $haut, $j, $this->graph_height,$this->color['green2']);
			imagerectangle($this->image, $i, $haut, $j, $this->graph_height,$this->color['green']);
		}
	}
	
	private function TracerMarge($index) {
		$tmp = $this->data->getSNRAt($index);
		$i = $index*$this->pas+$this->debut;
		$j = $i + $this->pas;
		if($tmp != "NONE" AND $tmp != "") {
			$ht = $this->graph_height / $this->getSNRMaxScale();
			$value = $ht * $tmp;
			$value = ($this->graph_height) - $value;
			imagerectangle ( $this->image, $i, $value, $j,$value+1, $this->color['blue']);						
		}
		
	}     

	private function TracerAttenuation($index) {
		$tmp = $this->data->getAttenuationAt($index);
		$i = $index*$this->pas+$this->debut;
		$j = $i + $this->pas;
		if($tmp != "NONE" AND $tmp != "") {
			$ht = $this->graph_height / 67;
			$value = $ht * $tmp;
			$value = ($this->graph_height) - $value;
			imagerectangle ( $this->image, $i, $value, $j,$value+1, $this->color['blue2']);						
		}
		
	}    
	
	private function TracerIP($index) {
		$tmp = $this->data->getIPAt($index);
		$tmp2 = $this->data->getIPAt($index-1);
		if(isset($tmp2) AND isset($tmp) AND $tmp != $tmp2) {
			$i = $index*$this->pas+$this->debut;
			imagerectangle ( $this->image,$i, $this->graph_height-20, $i+1, $this->graph_height-5, $this->color['ip']);
			imageline ( $this->image, $i, $this->graph_height-5, $i-3, $this->graph_height-8, $this->color['ip']);
			imageline ( $this->image, $i, $this->graph_height-6, $i-3, $this->graph_height-9, $this->color['ip']);
			imageline ( $this->image, $i+1, $this->graph_height-5, $i+4, $this->graph_height-8, $this->color['ip']);
			imageline ( $this->image, $i+1, $this->graph_height-6, $i+4, $this->graph_height-9, $this->color['ip']);		
		}
	}  
	
	
	private function TracerVoIP($index) {
		$tmp = $this->data->getVoIPAt($index);
	  if(($tmp != "OK" AND $tmp != 2 AND $tmp !=3) AND isset($tmp)) {
			$i = $index*$this->pas+$this->debut;			 
			imagerectangle ( $this->image,$i, $this->graph_height-29, $i+1, $this->graph_height-20, $this->color['voip']);
			imageline ( $this->image, $i, $this->graph_height-20, $i-3, $this->graph_height-23, $this->color['voip']);
			imageline ( $this->image, $i, $this->graph_height-21, $i-3, $this->graph_height-24, $this->color['voip']);
			imageline ( $this->image, $i+1, $this->graph_height-20, $i+4, $this->graph_height-23, $this->color['voip']);
			imageline ( $this->image, $i+1, $this->graph_height-21, $i+4, $this->graph_height-24, $this->color['voip']);
			imagefilledellipse( $this->image, $i+0.5, $this->graph_height-29, 7,6, $this->color['voip']);  
	  }
	} 
	
	private function TracerEchelle($size) {
	
		$point_max = $this->data->getMaxUptime();
		if($point_max > 5000) {
			$ecart = $point_max/600;
			$dur = "( ".I10N_HOUR." )";
		}
		elseif($point_max > 10000) {
			$ecart = $point_max/14400;
			$dur = "( ".I10N_DAY." )";
		}
		else {
			$ecart = $point_max/10;
			$dur = "( ".I10N_MIN." )";
		}

		$ecart = round($ecart);
		// Les valeurs de chaque barreau
		if($size == 'small') {
			imagestring($this->image, 2, 13, 3, $ecart*9, $this->color['green']);
			imagestring($this->image, 2, 13, 16, $ecart*8, $this->color['green']);
			imagestring($this->image, 2, 13, 30, $ecart*7, $this->color['green']);
			imagestring($this->image, 2, 13, 43, $ecart*6, $this->color['green']);
			imagestring($this->image, 2, 13, 57, $ecart*5, $this->color['green']);
			imagestring($this->image, 2, 13, 70, $ecart*4, $this->color['green']);
			imagestring($this->image, 2, 13, 84, $ecart*3, $this->color['green']);
			imagestring($this->image, 2, 13, 97, $ecart*2, $this->color['green']);
			imagestring($this->image, 2, 13, 111, $ecart, $this->color['green']);
			imagestring($this->image, 2, 13, 124, "0", $this->color['green']);
			imagestringup($this->image, 1, 0, 100, I10N_UPTIME." ".$dur, $this->color['green']);
		}
		elseif($size == 'high') {
			imagestring($this->image, 2, 17, 15, $ecart*9, $this->color['green']);
			imagestring($this->image, 2, 17, 33, $ecart*8, $this->color['green']);
			imagestring($this->image, 2, 17, 53, $ecart*7, $this->color['green']);
			imagestring($this->image, 2, 17, 73, $ecart*6, $this->color['green']);
			imagestring($this->image, 2, 17, 94, $ecart*5, $this->color['green']);
			imagestring($this->image, 2, 17, 114, $ecart*4, $this->color['green']);
			imagestring($this->image, 2, 17, 134, $ecart*3, $this->color['green']);
			imagestring($this->image, 2, 17, 154, $ecart*2, $this->color['green']);
			imagestring($this->image, 2, 17, 173, $ecart, $this->color['green']);
			imagestring($this->image, 2, 17, 195, "0", $this->color['green']);
			imagestringup($this->image, 2, 0, 150, I10N_UPTIME." ".$dur, $this->color['green']);
		}
		$ecart = $this->getSNRMaxScale()/10;
		if($size == 'small') {

			imagestring($this->image, 2, 625, 3, round($ecart*9), $this->color['blue']);
			imagestring($this->image, 2, 625, 15, round($ecart*8), $this->color['blue']);
			imagestring($this->image, 2, 625, 28, round($ecart*7), $this->color['blue']);
			imagestring($this->image, 2, 625, 41, round($ecart*6), $this->color['blue']);
			imagestring($this->image, 2, 625, 54, round($ecart*5), $this->color['blue']);
			imagestring($this->image, 2, 625, 67, round($ecart*4), $this->color['blue']);
			imagestring($this->image, 2, 625, 80, round($ecart*3), $this->color['blue']);
			imagestring($this->image, 2, 625, 93, round($ecart*2), $this->color['blue']);
			imagestring($this->image, 2, 625, 106, round($ecart), $this->color['blue']);
			imagestring($this->image, 2, 625, 119, "0", $this->color['blue']);
			imagestringup($this->image, 1, 640, 110, I10N_SNR." (db)", $this->color['blue']);
			//imagestringup($this->image, 1, 640, 130, I10N_AFF, $this->color['blue2']);
		}
		elseif($size == 'high') {
			imagestring($this->image, 2, 769, 14, round($ecart*9), $this->color['blue']);
			imagestring($this->image, 2, 769, 34, round($ecart*8), $this->color['blue']);
			imagestring($this->image, 2, 769, 54, round($ecart*7), $this->color['blue']);
			imagestring($this->image, 2, 769, 74, round($ecart*6), $this->color['blue']);
			imagestring($this->image, 2, 769, 94, round($ecart*5), $this->color['blue']);
			imagestring($this->image, 2, 769, 114, round($ecart*4), $this->color['blue']);
			imagestring($this->image, 2, 769, 134, round($ecart*3), $this->color['blue']);
			imagestring($this->image, 2, 769, 154, round($ecart*2), $this->color['blue']);
			imagestring($this->image, 2, 769, 174, round($ecart), $this->color['blue']);
			imagestring($this->image, 2, 769, 194, "0", $this->color['blue']);
			imagestringup($this->image, 2, 785, 190,I10N_SNR, $this->color['blue']);
			//imagestringup($this->image, 2, 785, 100, I10N_AFF, $this->color['blue2']);
		}
	}
	
	private function getSNRMaxScale() {
		if($this->data->getMaxSNR()<70) {
			return $this->data->getMaxSNR()*2;
		}
		return $this->data->getMaxSNR();
	
	}
}


?>
